 
#ifndef BOOST_PROCESS_POSIX_INITIALIZER_ARGS_HPP
#define BOOST_PROCESS_POSIX_INITIALIZER_ARGS_HPP

#include <boost/process/config.hpp>
#include <boost/process/posix/initializers/initializer.hpp>

#include <vector>

namespace boost { namespace process { namespace posix {

    struct executor;

    struct arg : public initializer 
    {
        typedef std::vector<char> chars;
        
        mutable chars m_chars;
        
        arg(const std::string& s) : m_chars(s.begin(), s.end()) {}
        
        void  pre_fork_parent(executor& e) const 
        { 
            e.m_arg_ptrs.push_back(&m_chars[0]); 
        } 
    };

    struct args : public initializer 
    {
        typedef std::vector<arg> args_type;
        
        args_type m_args;
        
        args(const std::string& s) : m_args(1, s) {}
        
        args& operator()(const arg& a)
        {
            m_args.push_back(a);
            
            return *this;
        }

        void  pre_fork_parent(executor& e) const 
        { 
            for_each(m_args.begin(), m_args.end(), lazy::pre_fork_parent(e));
        } 
    };

}}}

#endif // BOOST_PROCESS_POSIX_INITIALIZER_ARGS_HPP