
// 
// Copyright (c) 2011 Jeff Flinn
// 
// Distributed under the Boost Software License, Version 1.0. (See accompanying 
// file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt) 
// 

#ifndef BOOST_PROCESS_WINDOWS_INITIALIZER_HPP
#define BOOST_PROCESS_WINDOWS_INITIALIZER_HPP

namespace boost { namespace process { namespace windows {

struct executor;

struct initializer 
{
    void    pre_create(executor&) const {}
    void   post_create(executor&) const {}
    void failed_create(executor&) const {}

    struct lazy
    {
        struct pre_create
        {
            executor& m_e;

            pre_create(executor& e) : m_e(e) {}

            template<class I> void operator()(const I& i) const { return i.pre_create(m_e); }
        };
        struct post_create
        {
            executor& m_e;

            post_create(executor& e) : m_e(e) {}

            template<class I> void operator()(const I& i) const { return i.post_create(m_e); }
        };
        struct failed_create
        {
            executor& m_e;

            failed_create(executor& e) : m_e(e) {}

            template<class I> void operator()(const I& i) const { return i.failed_create(m_e); }
        };
    };
};

}}}

#endif
